#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include "PsxCommon.h"

#ifdef WIN32
#include <windows.h>
#endif

FILE* fpRecordingMovie = 0;
FILE* fpTempMovie = 0;
int flagDontPause = 1;
int HasEmulatedFrame = 0;
extern struct Movie_Type currentMovie;

void PCSX_MOV_StartMovie(int mode)
{
	currentMovie.mode = mode;
	if (currentMovie.mode == 1) {
		fpRecordingMovie = fopen("movie.txt","wb");
		currentMovie.readOnly = 0;
	}
	else if (currentMovie.mode == 2) {
		fpRecordingMovie = fopen("movie.txt","r+b");
		fpTempMovie = fopen("tmp.tmp","wb");
		currentMovie.readOnly = 1;
	}
}

static void movie_writeline(int i)
{
	char* str; char* p;

	str = malloc( sizeof(long)*8*sizeof(char) );
	p = str;
	while(i>0)
	{
		(i & 0x1) ? (*p++='1') : (*p++='0');
		i >>= 1;
	}
	while( p-- != str ) // print out the result backwards
		fprintf(fpRecordingMovie,"%c",*p);

	free(str);
	fprintf(fpRecordingMovie,"\n",1);
}

void PCSX_MOV_WriteJoy(int *js)
{
	movie_writeline(js);
	currentMovie.frameCounter++;
}

int PCSX_MOV_ReadJoy()
{
	char bin[16];int count=0; int stop=0;

	if(!feof(fpRecordingMovie)) {
		// read file
		do {
			char c = fgetc(fpRecordingMovie);
			if(feof(fpRecordingMovie))
				return(0);
			if (c == '\n') {
				bin[count] = NULL;
				stop=1;
			}
			else
				bin[count] = c;
			count++;
		} while (!stop);
		fprintf(fpTempMovie,"%s\n",bin);
//			SysPrintf("%d  %s\n",currentMovie.frameCounter,bin);
		currentMovie.frameCounter++;
//		if ( ((currentMovie.frameCounter-30)%400) == 0 ) {
//		if ( (currentMovie.frameCounter==535) || (currentMovie.frameCounter==480) ) {
//			PCSX_MOV_FrameCountSaveState();
////			PCSX_MOV_FrameCountLoadState();
//		}

		//convert binary to decimal
		int result=0; int i;
		for(i=0;i<=15;i++)
		{
			if (!bin[i]) break;
			if((bin[i]!='0')&&(bin[i]!='1')) {
//				SysPrintf("res: ERROR! %c\n",bin[i]);
				return -1;
			}
			result=result*2+(bin[i]-'0');
			if(result<=0) return -1;
		}
	
		return(result);
	}
	else return(0);
}

void PCSX_MOV_CopyMovie(int mode, char *file)
{
	FILE *from, *to;
	char ch;

	if (currentMovie.mode == 1) {
		fclose(fpRecordingMovie);
		// load savestate
		if (mode == 1) {
			from = fopen(file, "rb");
			if (from == NULL) return;
			to = fopen("movie.txt", "wb");
		}
		// save state
		else {
			from = fopen("movie.txt", "rb");
			to = fopen(file, "wb");
		}
	
		/* copy the file */
		if (mode == 1) currentMovie.frameCounter = 0;
		while(!feof(from)) {
			ch = fgetc(from);
			if ( (mode == 1) && (ch == '\n') ) currentMovie.frameCounter++;
			if(ferror(from)) {
				SysPrintf("MOVIE: Error reading source file.\n");
			}
			if(!feof(from)) fputc(ch, to);
			if(ferror(to)) {
				SysPrintf("MOVIE: Error writing destination file.\n");
			}
		}

		fclose(to);fclose(from);
		fpRecordingMovie = fopen("movie.txt","r+b");
		fseek(fpRecordingMovie,0,SEEK_END);
	}
	else if (currentMovie.mode == 2) {
		// load savestate
		if (mode == 1) {
			int size;
			if (fpTempMovie) fclose(fpTempMovie);

			from = fopen(file, "rb");
			if (from == NULL) return;
			fpTempMovie = fopen("tmp.tmp","wb");
			currentMovie.frameCounter = 0;
				/* copy the file */
			while(!feof(from)) {
				ch = fgetc(from);
				if (ch == '\n') currentMovie.frameCounter++;
				if(ferror(from)) {
					SysPrintf("MOVIE: Error reading source file.\n");
				}
				if(!feof(from)) fputc(ch, fpTempMovie);
				if(ferror(fpTempMovie)) {
					SysPrintf("MOVIE: Error writing destination file.\n");
				}
			}
			fseek(from, 0, SEEK_END);
			fflush(from);
			size=ftell(from);
			close(from);
//			SysPrintf("%d\n",size);
			fflush(fpTempMovie);
			fseek(fpRecordingMovie, size, SEEK_SET);
		}
		else { // saving
			fclose(fpTempMovie);
			from = fopen("tmp.tmp", "rb");
			to = fopen(file, "wb");
					/* copy the file */
			while(!feof(from)) {
				ch = fgetc(from);
				if(ferror(from)) {
					SysPrintf("MOVIE: Error reading source file.\n");
				}
				if(!feof(from)) fputc(ch, to);
				if(ferror(to)) {
					SysPrintf("MOVIE: Error writing destination file.\n");
				}
			}
			fclose(to);fclose(from);
			fpTempMovie = fopen("tmp.tmp","ab");
		}
	}
}

void PCSX_DoEvents() {
	MSG msg;
	while(PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)) {
		if(msg.message==WM_QUIT) return;
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return;
}

void PCSX_MOV_FlushMovieFiles()
{
	if (fpRecordingMovie)
		fflush(fpRecordingMovie);
	if (fpTempMovie)
		fflush(fpTempMovie);
}

void PCSX_MOV_FrameCountSaveState()
{
	char Text[255];
	int ret;
	StatesC=8;
	sprintf(Text, "moviestates\\%10.10s.%dsm", CdromLabel, currentMovie.frameCounter);
	PCSX_MOV_CopyMovie(0,Text);
	sprintf(Text, "moviestates\\%10.10s.%dss", CdromLabel, currentMovie.frameCounter);
	GPU_freeze(2, (GPUFreeze_t *)&StatesC);
	ret = SaveState(Text);
	if (ret == 0)
		 sprintf(Text, _("*PCSX*: Saved State %d"), currentMovie.frameCounter);
	else sprintf(Text, _("*PCSX*: Error Saving State %d"), currentMovie.frameCounter);
	GPU_displayText(Text);
}

void PCSX_MOV_FrameCountLoadState()
{
	char Text[255];
	int ret;
	StatesC=8;
	sprintf(Text, "moviestates\\%10.10s.%dsm", CdromLabel, currentMovie.frameCounter);
	PCSX_MOV_CopyMovie(1,Text);
	sprintf (Text, "moviestates\\%10.10s.%dss", CdromLabel, currentMovie.frameCounter);
	ret = LoadState(Text);
	if (ret == 0)
		 sprintf(Text, _("*PCSX*: Loaded State %d"), currentMovie.frameCounter);
	else sprintf(Text, _("*PCSX*: Error Loading State %d"), currentMovie.frameCounter);
	GPU_displayText(Text);
}
